
function kscolormap = colormapKS ( option )

switch option
  case 'lines'
    kscolormap = createLinesColormap;
  case 'plot'
    kscolormap = createPlotColormap;
  case 'lines_ivc'
    kscolormap = createLinesIVCColormap;
  case 'motions'
    kscolormap = createMotionsColormap;
  case 'motionsegments'
    kscolormap = createMotionSegmentsColormap;
  otherwise
    error('no such option.');
end


  function kscolormap = createMotionsColormap
    kscolormap = [...
      0.00    0.00    0.00; ... % black
      0.99    0.72    0.08; ... % sunny orange
      0.00    1.00    0.80; ... % bright turquoise
      1.00    0.00    0.00; ... % red 
      0.75    1.00    0.00; ... % lime green
      0.40    0.00    0.70; ... % bluish violet
      0.96    0.91    0.58; ... % marzipan
      0.00    0.00    1.00; ... % blue
      0.96    0.48    0.15; ... % IVC orange
      0.33    0.83    0.25; ... % emerald green
      0.50    0.00    0.00; ... % dark red
      0.60    0.60    0.87; ... % cold (light) purple
      0.70    0.60    0.10; ... % Senf?
      0.63    0.14    0.53; ... % fuchsia
      0.04    0.80    0.93; ... % light blue
      0.00    0.50    0.00; ... % dark green
      1.00    0.40    0.00; ... % orange red
      0.00    0.00    0.50; ... % dark blue
      0.00    1.00    0.00; ... green
      0.30    0.70    0.00; ... % green
      0.70    0.00    0.00; ... % dark red
      0.20    0.87    0.87; ... % turquoise
      0.74    0.85    0.85; ... % mist
      0.02    0.46    0.75; ... % (IVC-BRSU) blue
      0.85    0.00    0.85; ... % magenta
      0.30    0.99    0.99; ... % cyan
      0.90    0.90    0.00; ... % dark yellow
      ];
  end

  function kscolormap = createPlotColormap
    kscolormap = [...
      0.00, 0.00, 1.00; ...
      0.00, 1.00, 0.00; ...
      1.00, 0.00, 0.00; ...
      0.00, 0.00, 0.50; ...
      0.00, 0.50, 0.00; ...
      0.50, 0.00, 0.00; ...
      0.00, 0.75, 0.75; ...
      0.75, 0.00, 0.75; ...
      0.75, 0.75, 0.00; ...
      0.25, 0.25, 0.25; ...
      ];
  end

%   [0.96    0.48    0.15]; ... % IVC orange
%   [0.02    0.46    0.75]; ... % (IVC-BRSU) blue
%   [0.70    0.70    0.70]; ... % IVC ?? gray
%   [0.00    0.00    0.70]; ... % dark blue
%   [0.00    0.70    0.00]; ... % dark green
%   [0.30    0.70    0.00]; ... % green
%   [0.40    0.00    0.70]; ... % bluish violet
%   [0.70    0.00    0.00]; ... % dark red
%   [0.80    0.00    0.00]; ... % red
%   [0.80    0.60    0.10]; ... % RM-AA

  function kscolormap = createLinesIVCColormap
  kscolormap = [ ...
    0.96    0.48    0.15; ... % IVC orange
    0.02    0.46    0.75; ... % (IVC-BRSU) blue
    0.70    0.70    0.70; ... % IVC ?? gray
    0.00    0.00    0.70; ... % dark blue
    0.00    0.70    0.00; ... % dark green
    0.30    0.70    0.00; ... % green
    0.40    0.00    0.70; ... % bluish violet
    0.70    0.00    0.00; ... % dark red
    0.80    0.00    0.00; ... % red
    0.80    0.60    0.10; ... % RM-AA
    ];
  end

  function kscolormap = createLinesColormap
  kscolormap = [ ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75;
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    0.00, 0.50, 0.00; ...
    1.00, 0.00, 0.00; ...
    0.00, 0.75, 0.75; ...
    0.75, 0.00, 0.75; ...
    0.75, 0.75, 0.00; ...
    0.25, 0.25, 0.25; ...
    0.00, 0.00, 1.00; ...
    ];
  end % of lines colormap function

  function kscolormap = createMotionSegmentsColormap
  kscolormap = [ ...
    %   0   0   0; ... 3.1 % black      0
     252 184  20; ... 3.2 % sunny orange  67476
      0 163 230;... % 2838
     191 255   0; ... 3.5 % lime green   52976
     228  26  28; ... 1.1 = 2.6 red       58812
    %  0 255 204; ... 3.3 % bright turquoise 4284
    %255   0   0; ... 3.4 % red       65280
    %102   0 179; ... 3.6 % bluish violet       26291
     255 255  51; ... 1.6  yellow       69411
    %245 232 148; ... 3.7 % marzipan      66580
    %  0   0 255; ... 3.8 % blue               255
     128   0   0; ... 3.11% dark red  32768
     189 217 217; ... 3.23% mist            52073
     152, 78,163; ... 1.4   violet              40323
      50  73 145;...  % 3.8 replacement      14113
    %245 122  38; ... 3.9 % IVC orange    64710
    % 84 212  65; ... 3.10% emerald green24961
     153 153 222; ... 3.12% cold (light) purple 41838
    %179 153  26; ... 3.13% Senf? 48298
     161  36 135; ... 3.14% fuchsia 41927 ?1
    % 10 204 237; ... 3.15% light blue        6061
       0 128   0; ... 3.16% dark green    2048
     255 255 153; ... 2.11 light yellow    65513
     255 102   0; ... 3.17% orange red    66912
       0   0 128; ... 3.18% dark blue          128
    %  0 255   0; ... 3.19% green         4080
      77 178   0; ... 3.20% green        22560
     179   0   0; ... 3.21% dark red  45824
    % 51 222 222; ... 3.22% turquoise       16830
       5 117 191; ... 3.24% (IVC-BRSU) blue   3343
    %217   0 217; ... 3.25% magenta 55769
    % 77 252 252; ... 3.26% cyan            23996
    %230 230   0; ... 3.27% dark yellow  62560

    % 55 126 184; ... 1.2                    16280
    % 77 175  74; ... 1.3                22586
    %255,127,  0; ... 1.5 = 2.8           67312
     166  86  40; ... 1.7         43912
     247 129 191; ... 1.8           65487
    %153 153 153; ... 1.9          41796

     166,206,227; ... 2.1                    46019
    % 31,120,180; ... 2.2                    10036
    %178 223 138; ... 2.3                49274
    % 51 160  44; ... 2.4                15660
    %251 154 153; ... 2.5             66873
    %253,191,111; ... 2.7                 67935
    %202,178,214; ... 2.9                       54774
     106, 61,154; ... 2.10                      28266 ?1
    %177  89  40; ... 2.12        46776
    ]/255;
  end % of motion segments colormap function

end % of function colormapks