function [demo, seq, seqGT] = demo_compareToReference( demo )

if ~isempty(demo.motion_annotation)
  demo.cutsGT = cuts2rects(demo.motion_annotation.cutsm,demo.motion.numberofframes);
  demo.cutsGT = demo.cutsGT(1:2:end,:);
  %[seqGT] = demo_generateSegmentsFromIntervals (demo.motion.numberofframes, demo.cutsGT);
  
  %% do the evaluation
  % overlap union ratio
  %measure_our_matKS_q = evaluateSegmentation ( demo.cutsGT, demo.cuts  , 'OverlapUnionRatio' );%, sim_thresh );
  %measure_our_matGT_q = evaluateSegmentation ( demo.cutsGT, demo.cutsGT, 'OverlapUnionRatio' );%, sim_thresh );
  measure_our_matKS_q = evaluateSegmentation ( demo.cuts, demo.cuts  , 'OverlapUnionRatio' );%, sim_thresh );
  measure_our_matGT_q = evaluateSegmentation ( demo.cuts, demo.cutsGT, 'OverlapUnionRatio' );%, sim_thresh );
  % maximize overlap union ratio per annotated segment 
  % (maximum match of hand annotated segment and automatic segment)
  measure_our_maxKS = maximizeEvaluationResult(measure_our_matKS_q, 'col');
  measure_our_maxKS = maximizeEvaluationResult(measure_our_maxKS, 'row');
  measure_our_maxGT = maximizeEvaluationResult(measure_our_matGT_q, 'col');
  measure_our_maxGT = maximizeEvaluationResult(measure_our_maxGT, 'row');
  segmentationQuality_overlapunion.KS = (max(measure_our_maxKS,[],1));  % mean3: std dev % mean5: std dev: 
  segmentationQuality_overlapunion.KS_mean = mean(segmentationQuality_overlapunion.KS);
  segmentationQuality_overlapunion.KS_std = std(segmentationQuality_overlapunion.KS);
  segmentationQuality_overlapunion.GT = (max(measure_our_maxGT,[],1));  % mean3: std dev % mean5: std dev: 
  segmentationQuality_overlapunion.GT_mean = mean(segmentationQuality_overlapunion.GT);
  segmentationQuality_overlapunion.GT_std = std(segmentationQuality_overlapunion.GT);

  demo.segmentationQuality_overlapunion = segmentationQuality_overlapunion;
  
  [seq] = demo_generateSegmentsFromIntervals2(...
      demo.motion.numberofframes, ...
      demo.cuts, ...
      segmentationQuality_overlapunion.KS,...
      measure_our_maxKS, ...
      size(demo.cuts,1)...size(demo.cutsGT,1)
      );
  [seqGT] = demo_generateSegmentsFromIntervals2(...
      demo.motion.numberofframes, ...
      demo.cutsGT, ...
      segmentationQuality_overlapunion.GT,...
      measure_our_maxGT, ...
      size(demo.cuts,1)...size(demo.cutsGT,1)
      );
  
else
  seqGT = [];
  try 
    [seq] = demo_generateSegmentsFromIntervals (demo.motion.numberofframes, demo.cuts);
  catch err
    display(err.message);
    seq = []; %01_11_ex03-rad-001-grasp-su03
  end
end


end % of function