function [sequence] = demo_generateSegmentsFromIntervals ( frame_count, intervals )
% intervals are none-overlapping here!

[cuts_all,cuts_type] = fillCutGaps(frame_count,intervals);

overlap = intervals(1:end-1,2)-intervals(2:end,1);
overlap_idx = find(overlap>0)+1;
if ~isempty(overlap_idx)
  error('ksfun:generateSegmentsFromIntervals2_local: intervals MUST be non-overlapping!');
end


% for this to work, the color palette's first color must be BLACK
color_idx = cumsum(cuts_type).*cuts_type+1; 

sequence = zeros(1,frame_count,3);
sequence_IDs = zeros(1,frame_count);

for k=1:length(color_idx)
  sequence_IDs(cuts_all(k,1):cuts_all(k,2)) = color_idx(k);
end
if ~isempty(find(sequence_IDs==0))
  display('strange');
end


set_of_colors = colormapKS('motions');
for k=1:length(sequence_IDs);
  idx_color = sequence_IDs(k);
  sequence(1,k,:) = set_of_colors(idx_color,:);
end


end %of function
