function [sequence] = demo_generateSegmentsFromIntervals2 (...
  frame_count, ...
  intervals, ...
  sim_measure, ...
  sim_measure2, ...
  nintervals_GT)%, ...
% intervals are none-overlapping here!



overlap = intervals(1:end-1,2)-intervals(2:end,1);
overlap_idx = find(overlap>0)+1;
if ~isempty(overlap_idx)
  error('ksfun:generateSegmentsFromIntervals2_local: intervals MUST be non-overlapping!');
end


% this alignes computation to ground truth 
[primary_color_idx, interval_idx] = find(sim_measure2);

interval_idx_without_color = find(~ismember(1:size(intervals,1),interval_idx));
secondary_color_idx = interval_idx_without_color-min(interval_idx_without_color)+nintervals_GT+1;
secondary_color_idx = [1:length(interval_idx_without_color)]+nintervals_GT;
primary_color_idx = primary_color_idx+1;
secondary_color_idx = secondary_color_idx+1;



if size(intervals,1) > length(sim_measure)
  sim_measure(size(intervals,1)) = 0;
end

sequence = zeros(1,frame_count,3);
sequence_IDs = ones(1,frame_count);
cut_count = length(intervals);

for k=1:length(interval_idx)
  idx = interval_idx(k);
  sequence_IDs(intervals(idx,1):intervals(idx,2)) = primary_color_idx(k);
end
for k=1:length(interval_idx_without_color)
  idx = interval_idx_without_color(k);
  sequence_IDs(intervals(idx,1):intervals(idx,2)) = secondary_color_idx(k);
end
if ~isempty(find(sequence_IDs==0))
  display('strange');
end


set_of_colors = colormapKS('motions');
for k=1:length(sequence_IDs);
  idx_color = sequence_IDs(k);
  sequence(1,k,:) = set_of_colors(idx_color,:);
end


end %of function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%