function [max_mat] = maximizeEvaluationResult ( eval_mat, row_or_col )
%
% INPUT
%   eval_mat ..... matrix to maximize the row or columns of
%   row_or_col ... string containing wether the maximization should be 
%                  done per row ('row') or per column ('col').
%
% OUTPUT
%   max_mat ... matrix containing the maximized evaluation results
%
% EXAMPLE
%
%

if isempty(eval_mat)
  max_mat = eval_mat;
  return;
end
b_1line_mat = false;
switch row_or_col
  case 'row'
    eval_mat = eval_mat';
    if size(eval_mat,1) == 1
      b_1line_mat = true;
      eval_mat(2,:) = 0;
    end
end

index_offset_width = size(eval_mat,2);
index_offset = size(eval_mat,1);

%% maximum match of hand annotated segment and automatic segment
[val, idx] = max(eval_mat);
try
  idx = idx+  (0:index_offset_width-1)*index_offset;
catch err
  display('something went wrong');
end
max_mat = zeros(size(eval_mat));
max_mat(idx) = val;

switch row_or_col
  case 'row'
    if b_1line_mat
      max_mat(2,:) = [];
    end
    max_mat = max_mat';
end

end % of function 