function [featuredata] = twenty16_HandSegmentation_loadFeaturedata ( skel, mot, temporalStack, theSet )
% loads stacked feature data
% 
%   skel ............ skeleton struct
%   mot ............. motion struct
%   theSet .......... string containing the feature set id
%   temporalStack ... row vector containing indices for data stacking
%

switch nargin
  case 2
    temporalStack = [ -6 -1 0 1 6 ];
    theSet = 'p15';
  case 3
    theSet = 'p15';
end

featureRelToRoot = featureSet(skel, mot, theSet, false);%'avs5');'p15');%a18
featuredata = stackData(featureRelToRoot', temporalStack)'; 

end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function valid = checkChosenFeatureSet_local ( featureSetID )
% featureSetID ... string identifying the feature set to use
% valid ... true if feature set id exists
%           false if it does not

valid = true;
switch featureSetID
  case {'a', 'cf5'}
  case {'b', 'd5'}
  case {'c', 'a18'}
  case {'d', 'a6'}
  case {'e', 'a5'}
  case 'f'
  case {'g', 'p15'}
  case {'h', 'ad18'}
  case {'i', 'v15'}
  case {'j','av5'}
  case {'k','pav20'}
  case {'l','avs5'}
  case {'m','cc5'}
  case {'n','cc4'}
  case {'o', 'ic4'}
  otherwise
    valid = false;
end

end %of function